Subject: Re: XT_ALIGN changed to use ALIGN breaks iproute2

From: Stephen Hemminger <[email-masked]>
Date: Tue, 30 Mar 2010 08:29:02 -0700

On Tue, 30 Mar 2010 16:01:18 +0100
Ben Hutchings <[email-masked]> wrote:

> On Tue, 2010-03-30 at 16:15 +0300, Alexey Dobriyan wrote:
> > On Tue, Mar 30, 2010 at 12:28 PM, Andreas Henriksson <[email-masked]> wrote:
> > > You updated the kernel header include/linux/netfilter/x_tables.h
> > > in torvalds/linux-2.6.git commit 42107f5009da223daa800d6da6904d77297ae829
> > > with the comment "Use ALIGN() macro while I'm at it for same types.".
> > >
> > > When this header was synced into iproute2 the build broke because the
> > > ALIGN macro apparently only is defined in kernel headers.
> > >
> > > (For iproute2 the problem was introduced in
> > > 8ecdcce08319d0e39b0d32c1d17db3f69d85a35c and found by Stephen
> > > and worked around in 609ceb807deba8e23 and edaaa11e5a3cf2c9c1a39)
> > >
> > > I'm guessing the problem in the iproute2 header sync is just a heads
> > > up for what's going to happen when distributions updates their
> > > system headers to match linux 2.6.33.
> > >
> > >
> > > Could someone who knows how the userspace version of the kernel
> > > headers are generated please find a suitable solution?
> > 
> > We can export ALIGN to userspace, but the name is so generic,
> > so it's not clear what breakage more risky.
> 

I put a hack in m_xt.c to keep iproute2 building.
But this is a temporary workaround until you guys figure out the
right answer.

--